// ------------------------------------------------------------------
// exemple-sched-setaffinity.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sched.h>

#define LG_LIGNE 256

int main(int argc, char *argv[])
{
	cpu_set_t  cpuset;
	int cpu;
	
	// Lire le numero de CPU dans le premier argument
	if ((argc != 2) || (sscanf(argv[1], "%d", & cpu) != 1)) {
		fprintf(stderr, "usage: %s cpu\n", argv[0]);
		exit(EXIT_FAILURE);
	}
	// Remplir l'ensemble avec le CPU indique
	CPU_ZERO(& cpuset);
	CPU_SET(cpu, &cpuset);
	
	// Fixer l'affinite.
	if (sched_setaffinity(0, sizeof(cpuset), & cpuset) !=0) {
		perror(argv[1]);
		exit(EXIT_FAILURE);
	}
	
	while (1) {
		fprintf(stdout, "Je suis sur le CPU %d\n", sched_getcpu());
		fflush(stdout);
		sleep(1);
	}
	return EXIT_SUCCESS;
}

