// ---------------------------------------------------------------------
// exemple-clock-gettime-01.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

void affiche_caracteristiques(const char * nom, clockid_t clock)
{
	struct timespec res;
	struct timespec hre;

	printf("%s : \n", nom);
	clock_getres  (clock, & res);
	clock_gettime (clock, & hre);
	printf("   resolution : %ld.%09ld\n", res.tv_sec, res.tv_nsec);
	printf("   heure :      %ld.%09ld\n", hre.tv_sec, hre.tv_nsec);
}

int main(void)
{
	affiche_caracteristiques("CLOCK_REALTIME",           CLOCK_REALTIME);	
	affiche_caracteristiques("CLOCK_MONOTONIC",          CLOCK_MONOTONIC);	
	affiche_caracteristiques("CLOCK_PROCESS_CPUTIME_ID", CLOCK_PROCESS_CPUTIME_ID);	
	affiche_caracteristiques("CLOCK_THREAD_CPUTIME_ID",  CLOCK_THREAD_CPUTIME_ID);
	affiche_caracteristiques("CLOCK_MONOTONIC_RAW",      CLOCK_MONOTONIC_RAW);	
	return EXIT_SUCCESS;
}

