// ---------------------------------------------------------------------
// exemple-gettimeofday-02.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#include <stdio.h> 
#include <stdlib.h> 
#include <unistd.h> 
#include <sys/time.h> 


#define MAX_MESURES 100 

int main(int argc, char * argv[]) 
{
	long int seuil; 
	struct timeval heure; 
	struct timeval debut; 
	struct timeval precedente; 
	struct timeval avant_preemption[MAX_MESURES]; 
	struct timeval apres_preemption[MAX_MESURES]; 
	long long int difference; 

	int nb_mesures = 0; 
	int i; 

	if ((argc != 2)
	 || (sscanf(argv[1], "%ld", & seuil) != 1)) { 
		fprintf(stderr, "usage: %s seuil-en-microsec\n",
		                argv[0]); 
		exit(EXIT_FAILURE); 
	}
	gettimeofday(& debut, NULL); 
	precedente = debut; 

	do { 
		gettimeofday(& heure, NULL); 
		difference  = heure.tv_sec - precedente.tv_sec; 
		difference *= 1000000; 
		difference += heure.tv_usec - precedente.tv_usec; 
		if (difference >= seuil) { 
			avant_preemption[nb_mesures] = precedente; 
			apres_preemption[nb_mesures] = heure; 
			nb_mesures ++; 
			if (nb_mesures >= MAX_MESURES) 
				break; 
		} 
		precedente = heure; 
	} while (heure.tv_sec - debut.tv_sec <= 5); 
	for (i = 0; i < nb_mesures ; i ++) 
		printf("[%d] %ld.%06ld  ->  %ld.%06ld\n", 
		        i + 1, 
		        avant_preemption[i].tv_sec, 
			avant_preemption[i].tv_usec, 
			apres_preemption[i].tv_sec, 
			apres_preemption[i].tv_usec);
	return EXIT_SUCCESS; 
}

