// ---------------------------------------------------------------------
// exemple-setitimer-02.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>

void handler_signal(int inutilise)
{
	struct timeval actuel;
	static struct timeval precedent = { 0, 0 };

	long int duree;
	static long int duree_min = -1;
	static long int duree_max =  0;
	static long int somme_durees = 0;
	float  duree_moy = 0.0;
	static int nb_mesures;

	gettimeofday(& actuel, NULL);
	if (precedent.tv_sec > 0) {
		duree  = actuel.tv_sec  - precedent.tv_sec;
		duree *= 1000000;  // conversion en micro-sec
		duree += actuel.tv_usec - precedent.tv_usec;
		if ((duree_min < 0) || (duree_min > duree))
			duree_min = duree;
		if (duree_max < duree)
			duree_max = duree;
		somme_durees += duree;
		nb_mesures ++;
		if (nb_mesures == 1000) {
			duree_moy = (float) somme_durees / nb_mesures;
			printf("min=%4ld  max=%4ld  moy=%.0f\n",
			       duree_min, duree_max, duree_moy);
			duree_min = -1;
			duree_max = 0;
			somme_durees = 0;
			nb_mesures = 0;
		}
	}
	precedent = actuel;
}


int main(int argc, char * argv[])
{
	struct itimerval timer;
	// Installer le handler du signal SIGALRM
	signal(SIGALRM, handler_signal);
	// Preparer la structure itimerval
	timer.it_interval.tv_sec = 0;
	timer.it_interval.tv_usec = 1000; // 1000 us = 1 ms
	timer.it_value = timer.it_interval;
	// Programmer le timer
	setitimer(ITIMER_REAL, & timer, NULL);
	while (1) 
		pause();
	return EXIT_SUCCESS;
}

