// ---------------------------------------------------------------------
// exemple-mesure-atmega.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------


// Declarer la frequence du micro-controleur (1MHz)
#define F_CPU 1000000
// Inclusion d'entetes specifiques au micro-controleur
#include <avr/io.h>
#include <util/delay.h>

void envoyer_octet (unsigned char octet)
{
	// Attendre buffer emission libre
	while ((UCSRA & (1<<UDRE)) == 0)
		;
	// Ecriture sur le port Usart Data Register
	UDR = octet;
}


int main(void)
{
	unsigned char uc;
	unsigned long int nb_boucles;

	// Parametrage du port de communication
	// 12 -> 9600 bits/sec
	UBRRH = (unsigned char) (0);
	UBRRL = (unsigned char) (12);
	// Clock x 2
	UCSRA = (1 << U2X);
	// TX et RX actives
	UCSRB = (1 << RXEN) | (1 << TXEN);
	// 8 bits, 1 stop, pas de parite
	UCSRC = (1 << URSEL) | (1 << UCSZ1) | (1 << UCSZ0);

	while (1) {
		nb_boucles = 0;

		envoyer_octet(0xFF);
		// Attendre 1 octet recu
		while ((UCSRA & (1 << RXC)) == 0)
			nb_boucles ++;
		// Lire l'octet
		uc = UDR;

		envoyer_octet((nb_boucles >> 24) & 0xFF);
		_delay_ms(2);
		envoyer_octet((nb_boucles >> 16) & 0xFF);
		_delay_ms(2);
		envoyer_octet((nb_boucles >> 8) & 0xFF);
		_delay_ms(2);
		envoyer_octet((nb_boucles >> 0) & 0xFF);
		_delay_ms(500);
	}
	return 0;
}


