// ---------------------------------------------------------------------
// exemple-reponse-irq-serie.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#include <fcntl.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <termios.h>
#include <unistd.h>
#include <sys/mman.h>

volatile int quitter = 0;

void handler_sigint(int unused)
{
	quitter = 1;
}

int main(int argc, char * argv[])
{
	int fd;
	unsigned char  octet;
	int nb_cycles;
	struct termios parametres;
	struct termios original;

	mlockall(MCL_CURRENT | MCL_FUTURE);

	if (argc != 2) {
		fprintf(stderr, "usage: %s port_serie\n", argv[0]);
		exit(EXIT_FAILURE);
	}

	signal(SIGINT, handler_sigint);
	
	if ((fd = open(argv[1], O_RDWR | O_NOCTTY | O_NONBLOCK)) < 0) {
		perror(argv[1]);
		exit(EXIT_FAILURE);
	}
	
	tcgetattr(fd, & original);
	tcgetattr(fd, & parametres);
	cfmakeraw(& parametres);
	cfsetispeed(& parametres, B9600);
	cfsetospeed(& parametres, B9600);
	parametres.c_iflag |= IGNPAR;
	parametres.c_cflag ^= (CSIZE | PARENB | CSTOPB);
	parametres.c_cflag |= CS8 | CLOCAL;
	if (tcsetattr(fd, TCSANOW, & parametres) != 0) {
		perror("tcsetattr");
		exit(EXIT_FAILURE);
	}
	fcntl(fd, F_SETFL, fcntl(fd, F_GETFL) ^ O_NONBLOCK);
		
	while (! quitter) {
		if (read(fd, & octet, 1) < 0) {
			perror(argv[1]);
			exit(EXIT_FAILURE);
		}
		if (write(fd, & octet, 1) < 0) {
			perror(argv[1]);
			exit(EXIT_FAILURE);
		}
		nb_cycles = 0;
		read(fd, & octet, 1);
		nb_cycles |= octet;
		nb_cycles <<= 8;
		read(fd, & octet, 1);
		nb_cycles |= octet;
		nb_cycles <<= 8;
		read(fd, & octet, 1);
		nb_cycles |= octet;
		nb_cycles <<= 8;
		read(fd, & octet, 1);
		nb_cycles |= octet;
		fprintf(stdout, "%d\n", nb_cycles);	
	}
	tcsetattr(fd, TCSANOW, & original);
	close(fd);
	fprintf(stderr, "Bye !\n");
	return EXIT_SUCCESS;
}
