// ---------------------------------------------------------------------
// exemple-threads-rr-02.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#include <pthread.h>
#include <sched.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

void * fonction_thread(void *);

#define NB_THREADS  5

pthread_barrier_t  barriere;

int main(void)
{	
	int i;
	int err;
	pthread_attr_t attr;
	struct sched_param param;
	pthread_t thr[NB_THREADS];

	pthread_barrier_init(& barriere, NULL, NB_THREADS);

	param.sched_priority = 80;	
	pthread_attr_init (& attr);
	if ((err = pthread_attr_setschedpolicy(& attr, SCHED_RR)) != 0) {
		fprintf(stderr, "setschedpolicy: %s\n", strerror(err));
		exit(EXIT_FAILURE);
	}
	if ((err = pthread_attr_setschedparam(& attr, & param)) != 0) {
		fprintf(stderr, "setschedparam: %s\n", strerror(err));
		exit(EXIT_FAILURE);
	}
	if ((err = pthread_attr_setinheritsched(& attr, PTHREAD_EXPLICIT_SCHED)) != 0) {
		fprintf(stderr, "setinheritsched: %s\n", strerror(err));
		exit(EXIT_FAILURE);
	}
	for (i = 0; i < NB_THREADS; i ++) {
		if ((err = pthread_create(& (thr[i]), & attr, fonction_thread, (void *) i)) != 0) {
			fprintf(stderr, "pthread_create: %s\n", strerror(err));
			exit(EXIT_FAILURE);
		}
	}
	for (i = 0; i < NB_THREADS; i ++)
		pthread_join(thr[i], NULL);

	return EXIT_SUCCESS;
}


void * fonction_thread(void * arg)
{
	int numero = (int) arg;
	int i, j;
	time_t debut, fin;
	pthread_barrier_wait(&barriere);
	time(& debut);
	for (i = 0; i < 100000; i ++)
		for (j = 0; j < 10000; j ++)
			;
	time(& fin);
	printf("[%d] %ld -> %ld\n",
	        numero, debut, fin);
	return NULL;
}

