// ---------------------------------------------------------------------
// exemple-interruption-01.c
// Fichier d'exemple du livre "Solutions Temps-Reel sous Linux"
// (C) 2012 - Christophe BLAESS
// http://christophe.blaess.fr
// ---------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>


int main(int argc, char * argv[])
{
	long int seuil;
	struct timeval debut;
	struct timeval heure;
	struct timeval precedente = {0, 0};
	long long int difference;
	
	if ((argc != 2) || (sscanf(argv[1], "%ld", & seuil) != 1)) {
		fprintf(stderr, "usage: %s seuil-en-microsec\n", argv[0]);
		exit(EXIT_FAILURE);
	}

	gettimeofday(& debut, NULL);
	precedente = debut;
	while(1) {
		gettimeofday(& heure, NULL);
		difference  = heure.tv_sec - precedente.tv_sec;
		difference *= 1000000;
		difference += heure.tv_usec - precedente.tv_usec;
		precedente = heure;
		if (difference >= seuil)
			fprintf(stderr, "%lld\n", difference);
		// Pause toutes les cinq secondes
		if (heure.tv_sec - debut.tv_sec > 5) {
			usleep(100000);
			gettimeofday(&debut, NULL);
			precedente = debut;
		}
	}
	return EXIT_SUCCESS;
}

